



#variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

    if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable ShowLogFlag 0

    variable JS ""

    variable ModuleMenu

    variable A16Base 0x0000
    variable A24Base 0x000000
    variable A32Base 0x00000000
    
    variable ModuleType
    variable ModuleName
    variable ModuleAddress
    variable NumModules 16

    for {set i 1} {$i <= $NumModules} {incr i} {
       set ModuleType($i) ""
       set ModuleName($i) ""
       set ModuleAddress($i) ""
    }

   variable moduletype [first $ModuleMenu]
   variable moduleindex 1

   variable index 0

   proc show_variables {} {
        variable A16Base
        variable A24Base
        variable A32Base
        variable LogFlag
        variable ShowLogFlag
        variable moduletype
        variable moduleindex
        variable index

        InsertLog "A16Base=$A16Base; A24Base=$A24Base; A32Base=$A32Base"
        InsertLog "LogFlag=$LogFlag; ShowLogFlag=$ShowLogFlag"
        InsertLog "moduletype=$moduletype; moduleindex=$moduleindex; index=$index"
   }
   
      proc do_Add {} {
        variable ModuleType
        variable ModuleName
        variable ModuleAddress
        variable NumModules
        variable JS
        variable A16Base
        variable A24Base
        variable A32Base
        variable moduleindex
        variable moduletype     
      
          for {set i 1} {$i <= $NumModules} {incr i} {
             if {[set ModuleType($i)] == ""} {break}
          }
          
          if {[set ModuleType($i)] != ""} {
            if {$JS == ""} {append JS "alert(\""}
            append JS "Module table full"
            return
          }
          
          set ModuleType($i) $moduletype
          set ModuleAddress($i) "$A16Base:$A24Base:$A32Base"
          
          switch $moduletype {
             CAEN_V785   {set ModuleName($i) v785#$moduleindex}
             CAEN_V775   {set ModuleName($i) v775#$moduleindex}
             CAEN_V830   {set ModuleName($i) v830#$moduleindex}
             CAEN_V560   {set ModuleName($i) v560#$moduleindex}
             SAC         {set ModuleName($i) sac#$moduleindex}
          }
      
      }
       
      proc do_Replace {} {
        variable ModuleType
        variable ModuleName
        variable ModuleAddress
        variable NumModules
        variable JS
        variable A16Base
        variable A24Base
        variable A32Base
        variable moduleindex
        variable moduletype    
        variable index 
      
          if {[set ModuleType($index)] == ""} {
            if {$JS == ""} {append JS "alert(\""}
            append JS "Module index not in use"
            return
          }
          
          set ModuleType($index) $moduletype
          set ModuleAddress($index) "$A16Base:$A24Base:$A32Base"
          
          switch $moduletype {
             CAEN_V785   {set ModuleName($index) v785#$moduleindex}
             CAEN_V775   {set ModuleName($index) v775#$moduleindex}
             CAEN_V830   {set ModuleName($index) v830#$moduleindex}
             CAEN_V560   {set ModuleName($index) v560#$moduleindex}
             SAC         {set ModuleName($index) sac#$moduleindex}
          }
      
      }
      
      proc do_Load {} {
        variable ConfigBase
        variable ModuleType
        variable ModuleName
        variable ModuleAddress
        variable JS

        InsertLog "Restoring VME Configuration"

        set ConfigFile [file join $ConfigBase VMEConfig.dat]

        set z [catch {open $ConfigFile r} file]
        if {$z != 0} {
            if {$JS == ""} {append JS "alert(\""}
            append JS "Unable to access $ConfigFile"
            InsertLog "Load unable to access $ConfigFile: [set file]"
            return
        }

        set i 1
        foreach item [split [read $file] \n] {
            if {[string length $item] == 0} {continue}
            set ModuleType($i) [first $item]
            set ModuleName($i) [second $item]
            set ModuleAddress($i) [third $item]
            incr i 1
        }

        close $file

        InsertLog "Done"

        Elog INFORMATION "VME Configuration restored from $ConfigFile"
    }

      proc do_Select {i} {
        variable ModuleType
        variable ModuleName
        variable ModuleAddress
        variable JS
        variable index
        variable A16Base
        variable A24Base
        variable A32Base
        variable moduleindex
        variable moduletype    
      
         if {[set ModuleType($i)] == ""} {
            if {$JS == ""} {append JS "alert(\""}
            append JS "Module index not in use"
            return
          }
          
         set index $i
         set A16Base [first [split [set ModuleAddress($i)] :]]
         set A24Base [second [split [set ModuleAddress($i)] :]]
         set A32Base [third [split [set ModuleAddress($i)] :]]
         
         set moduletype [set ModuleType($i)]
         set moduleindex [second [split [set ModuleName($i)] #]]
    }
    
      proc do_Delete {} {
        variable ModuleType
        variable ModuleName
        variable ModuleAddress
        variable index

       set ModuleType($index) ""
       set ModuleName($index) ""
       set ModuleAddress($index) ""
    }
    
      proc do_Clear {} {
        variable ModuleType
        variable ModuleName
        variable ModuleAddress
        variable NumModules  
      
          for {set i 1} {$i <= $NumModules} {incr i} {
             set ModuleType($i) ""
             set ModuleName($i) ""
             set ModuleAddress($i) ""
          }
      }
  
      proc do_Save {} {
        variable ConfigBase
        variable ModuleType
        variable ModuleName
        variable ModuleAddress
        variable NumModules
        variable JS
      
        InsertLog "Saving VME Configuration"

        set ConfigFile [file join $ConfigBase VMEConfig.dat]

        set z [catch {open $ConfigFile w} file]
        if {$z != 0} {
            if {$JS == ""} {append JS "alert(\""}
            append JS "Unable to access $ConfigFile"
            InsertLog "Save unable to access $ConfigFile: [set file]"
            return
        }
        
          for {set i 1} {$i <= $NumModules} {incr i} {
             if {[set ModuleType($i)] == ""} {continue}
             puts $file "[set ModuleType($i)] [set ModuleName($i)] [set ModuleAddress($i)]"
          }

        close $file

        InsertLog "Done"

        Elog INFORMATION "VME Configuration saved to $ConfigFile"
    }
    
    
   proc  do_click {}  {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag

      set cgidata [ncgi::nvlist]

      if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

      if {[llength $cgidata] == 0} then {return}

      if {[llength $cgidata] < 2} then {
         InsertLog "CGI data is too short: $cgidata"
      } else {
        if {[lindex $cgidata 0] != "Widget"} then {
            InsertLog "Invalid CGI data: $cgidata"
        } else {
           set w [lindex $cgidata 1]

           switch -glob [lindex $w 0] {

                RESET    {set started 0}
                CLEAR    {EmptyLog}
                ELOG     {PrintLog}
                RELOAD   {}
                VARIABLES {show_variables}

                HIDE     {set ShowLogFlag 0}
                SHOW     {set ShowLogFlag 1}
                LOGON    {set LogFlag 1}
                LOGOFF   {set LogFlag 0}

                   ADDRESS  {
                         switch [lindex $w 1] {
                             A16   {variable A16Base; set A16Base [lindex $w 2]; InsertLog "A16 Base = $A16Base"}
                             A24   {variable A24Base; set A24Base [lindex $w 2]; InsertLog "A24 Base = $A24Base"}
                             A32   {variable A32Base; set A32Base [lindex $w 2]; InsertLog "A32 Base = $A32Base"}
                         }
                   }

                ADD     {do_Add}
                REPLACE {do_Replace}
                DELETE  {do_Delete}
                CLR     {do_Clear}
                SAVE    {do_Save}
                LOAD    {do_Load}

                INDEX {variable moduleindex; set moduleindex [lindex $w 1]}
                TYPE  {variable moduletype;  set moduletype [lindex $w 1]}
      
                CONFIG  {do_Select [lindex $w 1]}

                undefined {}
                default  {InsertLog "unexpected cgi data:  $cgidata"}
            }
         }
       }
    }


}  ;# end of if {$started == 0}

