

#variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1


    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable ShowLogFlag 0

    variable JS ""

    variable A16Base 0x0400
    variable A24Base 0x000000
    variable A32Base 0x00000000

    variable Base $A16Base
    variable AddrMod 0x29
    variable DWidth  16

    variable cbus 0
    variable mon2 0
    variable str  0
    variable mode 0
    variable mon0 0
    variable sm   0
    variable evcnt 0
    variable acq   0

    variable delr 0

     if {$LogFlag == 1} {InsertLog "Started: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

   proc show_variables {} {
        variable A16Base
        variable A24Base
        variable A32Base
        variable ShowLogFlag
        variable LogFlag
        variable JS

         if {$ShowLogFlag == 1} {
             EmptyLog
             InsertLog "A16Base=$A16Base; A24Base=$A24Base; A32Base=$A32Base"
             InsertLog "LogFlag=$LogFlag; ShowLogFlag=$ShowLogFlag"
         }  else {
             if {$JS == ""} {append JS "alert(\""}
             append JS "A16Base=$A16Base; A24Base=$A24Base; A32Base=$A32Base; "
             append JS "LogFlag=$LogFlag; ShowLogFlag=$ShowLogFlag"
         }
   }

    proc click-delr {vl} {
        variable Base
        variable AddrMod
        variable DWidth

        set address 0x00
        set rc [wtVME -a [expr $Base + $address] -w $DWidth -m $AddrMod -d $vl]
    }

    proc click-mon0 {vl} {
        variable Base
        variable AddrMod
        variable DWidth

        set address 0x16
        set rc [wtVME -a [expr $Base + $address] -w $DWidth -m $AddrMod -d $vl]
   }

    proc click-mon2 {vl} {
        variable Base
        variable AddrMod
        variable DWidth

        set address 0x08
        set rc [wtVME -a [expr $Base + $address] -w $DWidth -m $AddrMod -d $vl]
   }

    proc click-mode {vl} {
        variable Base
        variable AddrMod
        variable DWidth

        set address 0x0e
        set rc [wtVME -a [expr $Base + $address] -w $DWidth -m $AddrMod -d $vl]
   }

    proc click-arm {} {
        variable Base
        variable AddrMod
        variable DWidth

        set address 0x14
        set rc [wtVME -a [expr $Base + $address] -w $DWidth -m $AddrMod -d 0]
    }

    proc click-acq {} {
        variable Base
        variable AddrMod
        variable DWidth

        variable acq

        set acq [expr ($acq + 1) & 1]    ;# toggle bit

        set address 0x02
        set rc [rdVME -a [expr $Base + $address] -w $DWidth -m $AddrMod]
        set vl [second $rc]

        set vl [expr ($vl & 0xfe) + $acq]

        set address 0x02
        set rc [wtVME -a [expr $Base + $address] -w $DWidth -m $AddrMod -d $vl]
    }

    proc click-evclr {} {
        variable Base
        variable AddrMod
        variable DWidth

        set address 0x10
        set rc [wtVME -a [expr $Base + $address] -w $DWidth -m $AddrMod -d 0]
    }

    proc click-str {vl} {
        variable Base
        variable AddrMod
        variable DWidth

        set address 0x02
        set rc [wtVME -a [expr $Base + $address] -w $DWidth -m $AddrMod -d $vl]
    }


    proc click-redisplay {} {
        variable Base
        variable AddrMod
        variable DWidth
        variable JS

        variable cbus 
        variable mon2 
        variable str
        variable mode
        variable mon0
        variable sm
        variable evcnt
        variable acq

        variable delr

        set address 0x00     ;#  DELR
        set rc [rdVME -a [expr $Base + $address] -w $DWidth -m $AddrMod]; InsertLog "$Base $rc"
        if {[first $rc] != 0} {
             if {$JS == ""} {append JS "alert(\""}
             append JS "rdVME -a [format 0x%04x [expr $Base + $address]] returned rc=[first $rc]"
        } else {
            set vl [second $rc]
            set delr [expr $vl & 255]
        }

        set address 0x02     ;#  STR
        set rc [rdVME -a [expr $Base + $address] -w $DWidth -m $AddrMod]
        set vl [second $rc]
        set str [format "0x%x" [expr $vl & 255]]

        set address 0x02     ;#  Enable
        set rc [rdVME -a [expr $Base + $address] -w $DWidth -m $AddrMod]
        set vl [second $rc]
        set acq [expr $vl &  1]

        set address 0x06     ;#  EVCNT
        set rc [rdVME -a [expr $Base + $address] -w $DWidth -m $AddrMod]
        set vl [second $rc]
        set evcnt $vl

        set address 0x0c     ;#  SM
        set rc [rdVME -a [expr $Base + $address] -w $DWidth -m $AddrMod]
        set vl [second $rc]
        set sm $vl

        set address 0x08     ;#  MON2
        set rc [rdVME -a [expr $Base + $address] -w $DWidth -m $AddrMod]
        set vl [second $rc]
        set mon2 $vl

        set address 0x16     ;#  MON0
        set rc [rdVME -a [expr $Base + $address] -w $DWidth -m $AddrMod]
        set vl [second $rc]
        set mon0 $vl

        set address 0x04     ;#  CBUS
        set rc [rdVME -a [expr $Base + $address] -w $DWidth -m $AddrMod]
        set vl [second $rc]
        set cbus $vl

        set address 0x0e     ;#  Mode
        set rc [rdVME -a [expr $Base + $address] -w $DWidth -m $AddrMod]
        set vl [second $rc]
        set mode $vl

}



     proc do_click {} {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {
               set w [lindex $cgidata 1]

               switch -glob [lindex $w 0] {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {}
                   VARIABLES {show_variables}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

                   ADDRESS  {
                         switch [lindex $w 1] {
                             A16   {variable A16Base; set A16Base [lindex $w 2]; InsertLog "A16 Base = $A16Base"; variable Base; set Base $A16Base}
                             A24   {variable A24Base; set A24Base [lindex $w 2]; InsertLog "A24 Base = $A24Base"}
                             A32   {variable A32Base; set A32Base [lindex $w 2]; InsertLog "A32 Base = $A32Base"}
                         }
                   }

                   OFFSET   {click-delr [lindex $w 2]}

                   ARM        {click-arm}
                   EVCLR      {click-evclr}
                   SMRST      {click-str 2; click-str 0}
                   ACQ        {click-acq}

                   MON0       {click-mon0 [lindex $w 1]}
                   MON2       {click-mon2 [lindex $w 1]}
                   MODE       {click-mode [lindex $w 1]}

                   REDISPLAY  {} 

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data:  $cgidata"}
               }
               click-redisplay
           }
       }
    }

}   ;# end of if {$started == 0}

