

#variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag
     variable Base
     variable ModuleIndex

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    if {$Base == -1}  {do_Select $ModuleIndex}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1


    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable ShowLogFlag 0

    variable JS ""

    variable A16Base 0x0000
    variable A24Base 0x000000
    variable A32Base 0x00000000

    variable Base -1
    variable AddrMod 0x09     ;#  A32UD
    variable DWidth  16

    variable online 0
    variable overflow 0
    variable zero 0
    variable alltdcs 0
    variable allmodules 0
    variable stopstart 0
    variable fastclear 40
    variable fullscale 100

    variable OperationMode 0
    for {set i 0} {$i < 32} {incr i} {variable Enable$i 1}
    for {set i 0} {$i < 32} {incr i} {variable Threshold$i $i}

    variable ModuleMenu {}
    variable ModuleAddress {}
    variable ModuleIndex 1

     if {$LogFlag == 1} {InsertLog "Started: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

   proc show_variables {} {
        variable A16Base
        variable A24Base
        variable A32Base
        variable Base
        variable ShowLogFlag
        variable LogFlag
        variable JS
        variable ModuleIndex
        variable ModuleMenu
        variable ModuleAddress
        variable alltdcs
        variable allmodules

         if {$ShowLogFlag == 1} {
             EmptyLog
             InsertLog "A16Base=$A16Base; A24Base=$A24Base; A32Base=$A32Base "
             InsertLog "LogFlag=$LogFlag; ShowLogFlag=$ShowLogFlag "
             InsertLog "Base=$Base; ModuleMenu=$ModuleMenu; ModuleIndex=$ModuleIndex; "
             InsertLog "alltdcs=$alltdcs; allmodules=$allmodules"
         }  else {
             if {$JS == ""} {append JS "alert(\""}
             append JS "A16Base=$A16Base; A24Base=$A24Base; A32Base=$A32Base; "
             append JS "LogFlag=$LogFlag; ShowLogFlag=$ShowLogFlag; "
             append JS "Base=$Base; ModuleMenu=$ModuleMenu; ModuleIndex=$ModuleIndex; "
             append JS "alltdcs=$alltdcs; allmodules=$allmodules"
         }
   }

   proc do_Select {i} {    ;# select module
        variable ModuleIndex
        variable A16Base
        variable A24Base
        variable A32Base
        variable Base
        variable ModuleAddress

         set ModuleIndex $i

         set address [lindex $ModuleAddress [expr $ModuleIndex - 1]]

         set A16Base [first [split $address :]]
         set A24Base [second [split $address :]]
         set A32Base [third [split $address :]]

         set Base $A32Base

         UpdateModule
   }

    proc UpdateModule {} {
        variable Base
        variable AddrMod
        variable DWidth
        variable JS

        variable online
        variable overflow
        variable zero
        variable stopstart
        variable fastclear
        variable fullscale

        variable OperationMode
        for {set i 0} {$i < 32} {incr i} {variable Enable$i}
        for {set i 0} {$i < 32} {incr i} {variable Threshold$i}

        set address 0x102e     ;#  FastClear
        set rc [rdVME -a [expr $Base + $address] -w $DWidth -m $AddrMod]
        if {[first $rc] != 0} {
             if {$JS == ""} {append JS "alert(\""}
             append JS "rdVME -a [format 0x%08x [expr $Base + $address]] -w $DWidth -m $AddrMod \
                 returns rc=[first $rc]; "
        } else {
            set vl [second $rc]
            set fastclear $vl
        }

        set address 0x1060     ;#  Full Scaler Range
        set rc [rdVME -a [expr $Base + $address] -w $DWidth -m $AddrMod]
        if {[first $rc] != 0} {
             if {$JS == ""} {append JS "alert(\""}
             append JS "rdVME -a [format 0x%08x [expr $Base + $address]] -w $DWidth -m $AddrMod \
                 returns rc=[first $rc]; "
        } else {
            set vl [second $rc]
            set fullscale $vl
        }

        set address 0x1032     ;#  Bit Set 2
        set rc [rdVME -a [expr $Base + $address] -w $DWidth -m $AddrMod]
        if {[first $rc] != 0} {
             if {$JS == ""} {append JS "alert(\""}
             append JS "rdVME -a [format 0x%08x [expr $Base + $address]] -w $DWidth -m $AddrMod \
                 returns rc=[first $rc]; "
        } else {
            set vl [second $rc]
            set OperationMode $vl
            set online [expr $vl >> 1 & 1]
            set overflow [expr $vl >> 3 & 1]
            set zero [expr $vl >> 4 & 1]
            set stopstart [expr $vl >> 10 & 1]
        }

        for {set i 0; set address 0x1080} {$i < 32} {incr i 1; incr address 2} {
            set rc [rdVME -a [expr $Base + $address] -w $DWidth -m $AddrMod]
            if {[first $rc] != 0} {
                if {$JS == ""} {append JS "alert(\""}
                append JS "rdVME -a [format 0x%08x [expr $Base + $address]] -w $DWidth -m $AddrMod \
                    returns rc=[first $rc]; "
                break
            }
            set Threshold$i [expr [second $rc] & 255]
            set Enable$i [expr ([second $rc] >> 8) & 1]
        }
   }

    proc do_SetOperationMode {w v} {
        variable Base
        variable AddrMod
        variable DWidth
        variable ModuleIndex
        variable ModuleMenu
        variable JS

        variable allmodules

       switch $w {
           ONLINE    {set data 0x02}
           OVERFLOW  {set data 0x08}
           THRESHOLD {set data 0x10}
           VALC      {set data 0x20}
           SSE       {set data 0x80}
           SSSE      {set data 0x2000}
           STOPSTART {set data 0x400}
           EVMODE    {set data 0x1000}
           EVCMODE   {set data 0x4000}
           BIT15     {set data 0x8000}
       }

       switch $v {
          0         {set address 0x1034}   ;#  Bit_Set_2
          1         {set address 0x1032}   ;#  Bit_Clear_2
       }

          set SAV $ModuleIndex
          foreach module $ModuleMenu {
              if {$allmodules == 0 && $module != $ModuleIndex} {continue}
              do_Select $module
              set rc [wtVME -a [expr $Base + $address] -w $DWidth -m $AddrMod -d $data]
              if {[first $rc] != 0} {
                 if {$JS == ""} {append JS "alert(\""}
                 append JS "wtVME -a [format 0x%08x [expr $Base + $address]] -w $DWidth -m $AddrMod \
                     returns rc=[first $rc]; "
              }
          }
          do_Select $SAV

    }

    proc do_OperationMode {v} {
        variable Base
        variable AddrMod
        variable DWidth
        variable ModuleIndex
        variable ModuleMenu
        variable JS

       set address 0x1034   ;#  Bit_Clear_2
       set data 0xffff
       set rc [wtVME -a [expr $Base + $address] -w $DWidth -m $AddrMod -d $data]
       if {[first $rc] != 0} {
           if {$JS == ""} {append JS "alert(\""}
           append JS "wtVME -a [format 0x%08x [expr $Base + $address]] -w $DWidth -m $AddrMod \
               returns rc=[first $rc]; "
       }

       set address 0x1032   ;#  Bit_Set_2
       set data $v
       set rc [wtVME -a [expr $Base + $address] -w $DWidth -m $AddrMod -d $data]
       if {[first $rc] != 0} {
           if {$JS == ""} {append JS "alert(\""}
           append JS "wtVME -a [format 0x%08x [expr $Base + $address]] -w $DWidth -m $AddrMod \
               returns rc=[first $rc]; "
       }

    }

     proc do_SetThreshold {j vl} {
        variable ModuleIndex
        variable ModuleMenu

        variable allmodules
        variable alltdcs

        set SAV $ModuleIndex
        foreach module $ModuleMenu {
           if {$allmodules == 0 && $module != $ModuleIndex} {continue}
           do_Select $module

           for {set i 0} {$i < 32} {incr i 1} {
              if {$alltdcs == 0 && $j != $i} {continue}

              do_Threshold $i $vl
           }
        }
        do_Select $SAV
     }

     proc do_Threshold {i vl} {
        variable Base
        variable AddrMod
        variable DWidth
        variable JS
 
        for {set j 0} {$j < 32} {incr j} {variable Enable$j}
        for {set j 0} {$j < 32} {incr j} {variable Threshold$j}

        set address [expr 0x1080 + ($i * 2)]

              set rc [wtVME -a [expr $Base + $address] -w $DWidth -m $AddrMod -d [expr ([set Enable$i] << 8) + $vl]]
              if {[first $rc] != 0} {
                  if {$JS == ""} {append JS "alert(\""}
                  append JS "wtVME -a [format 0x%08x [expr $Base + $address]] -w $DWidth -m $AddrMod \
                      returns rc=[first $rc]; "
              } else {
                 InsertLog "V775: Set Threshold $i = $vl"
                 set Threshold$i $vl
              }
      }

     proc do_SetFastClear {vl} {
        variable ModuleIndex
        variable ModuleMenu

        variable allmodules

          set SAV $ModuleIndex
          foreach module $ModuleMenu {
              if {$allmodules == 0 && $module != $ModuleIndex} {continue}
              do_Select $module

              do_FastClear $vl

          }
          do_Select $SAV
     }

     proc do_FastClear {vl} {
        variable Base
        variable AddrMod
        variable DWidth
        variable JS
        variable fastclear

          set address 0x102e    ;#  fast clear window

              set rc [wtVME -a [expr $Base + $address] -w $DWidth -m $AddrMod -d $vl]
              if {[first $rc] != 0} {
                  if {$JS == ""} {append JS "alert(\""}
                  append JS "wtVME -a [format 0x%08x [expr $Base + $address]] -w $DWidth -m $AddrMod \
                      returns rc=[first $rc]; "
              } else {
                 InsertLog "V775: Set Fast Clear Window = $vl"
                 set fastclear $vl
              }
     }

     proc do_SetFullScale {vl} {
        variable ModuleIndex
        variable ModuleMenu

        variable allmodules

          set SAV $ModuleIndex
          foreach module $ModuleMenu {
              if {$allmodules == 0 && $module != $ModuleIndex} {continue}
              do_Select $module

              do_FullScale $vl
          }
          do_Select $SAV
     }

     proc do_FullScale {vl} {
        variable Base
        variable AddrMod
        variable DWidth
        variable JS
        variable fullscale

        set address 0x1060   ;# full scale range

              set rc [wtVME -a [expr $Base + $address] -w $DWidth -m $AddrMod -d $vl]
              if {[first $rc] != 0} {
                  if {$JS == ""} {append JS "alert(\""}
                  append JS "wtVME -a [format 0x%08x [expr $Base + $address]] -w $DWidth -m $AddrMod \
                      returns rc=[first $rc]; "
              } else {
                 InsertLog "V775: Set Full Scale Range = $vl"
                 set fullscale $vl
              }
      }

     proc do_SetEnable {j vl} {
        variable ModuleIndex
        variable ModuleMenu

        variable allmodules
        variable alltdcs

        if {$vl == "true"} {set Vl 0} else {set Vl 1}

        set SAV $ModuleIndex
        foreach module $ModuleMenu {
          if {$allmodules == 0 && $module != $ModuleIndex} {continue}
          do_Select $module

          for {set i 0} {$i < 32} {incr i 1} {
            if {$alltdcs == 0 && $j != $i} {continue}

            do_Enable $i $Vl
          }
        }
        do_Select $SAV
     }

     proc do_Enable {i vl} {
        variable Base
        variable AddrMod
        variable DWidth
        variable JS
 
        for {set j 0} {$j < 32} {incr j} {variable Enable$j}
        for {set j 0} {$j < 32} {incr j} {variable Threshold$j}

        set address [expr 0x1080 + ($i * 2)]

              set rc [wtVME -a [expr $Base + $address] -w $DWidth -m $AddrMod -d [expr ($vl << 8) + [set Threshold$i]]]
              if {[first $rc] != 0} {
                  if {$JS == ""} {append JS "alert(\""}
                  append JS "wtVME -a [format 0x%08x [expr $Base + $address]] -w $DWidth -m $AddrMod \
                      returns rc=[first $rc]; "
              } else {
                 InsertLog "V775: Set Enable $i = $vl"
                 set Enable$i $vl
              }
      }

    proc do_Save {} {
        variable ::VMEConfig::ConfigBase
        variable JS
        variable Base
        variable ModuleIndex
        variable ModuleMenu

        variable OperationMode
        variable fastclear
        variable fullscale
        for {set i 0} {$i < 32} {incr i} {variable Enable$i}
        for {set i 0} {$i < 32} {incr i} {variable Threshold$i}

        set SaveFile [file join $ConfigBase V775.dat]

        set z [catch {open $SaveFile w} file]
        if {$z != 0} {
            if {$JS == ""} {append JS "alert(\""}
            append JS "Unable to access $SaveFile"
            InsertLog "[set file]"
            return
        }

        set SAV $ModuleIndex
        foreach module $ModuleMenu {
           do_Select $module
           InsertLog "Saving Settings for CAEN V775 modules"

           puts $file "$module OperationMode $OperationMode"
           puts $file "$module FastClear $fastclear"
           puts $file "$module FullScaleRange $fullscale"

           for {set i 0} {$i < 32} {incr i} {
               puts $file "$module Threshold$i [set Threshold$i]"
               puts $file "$module Enable$i [set Enable$i]"
           }
        }
        do_Select $SAV

        close $file

        InsertLog "Done"

        Elog INFORMATION "Settings for CAEN V775 modules updated in $SaveFile"
    }

    proc do_Restore {} {
        variable ::VMEConfig::ConfigBase
        variable JS
        variable Base
        variable ModuleIndex

        InsertLog "Restoring Settings for CAEN V775 modules"

        set SaveFile [file join $ConfigBase V775.dat]

        set z [catch {open $SaveFile r} file]
        if {$z != 0} {
            if {$JS == ""} {append JS "alert(\""}
            append JS "Unable to access $SaveFile"
            InsertLog "[set file]"
            return
        }

        set SAV $ModuleIndex
        foreach item [split [read $file] \n] {
            if {[string length $item] == 0} {continue}
            set m [first $item]
            if {$m != $ModuleIndex} {do_Select $m}
            set p [second $item]
            set vl [third $item]
            switch -glob $p {
                OperationMode   {do_OperationMode $vl}
                FastClear       {do_FastClear $vl}
                FullScaleRange  {do_FullScale $vl}
                Threshold*      {do_Threshold [string range $p 9 end] $vl}
                Enable*         {do_Enable [string range $p 6 end] $vl}
            }
        }
        do_Select $SAV

        close $file

        InsertLog "Done"

        Elog INFORMATION "Settings for CAEN V775 modules restored from $SaveFile"
    }

     proc do_click {} {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {
               set w [lindex $cgidata 1]

               switch -glob [lindex $w 0] {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {}
                   VARIABLES {show_variables}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

                   ALLTDCS    {variable alltdcs; set alltdcs [expr ($alltdcs + 1) & 1]}
                   ALLMODULES {variable allmodules; set allmodules [expr ($allmodules + 1) & 1]}

                   MODULE   {do_Select [lindex $w 1]}

                   ADDRESS  {
                         switch [lindex $w 1] {
                             A16   {variable A16Base; set A16Base [lindex $w 2]; InsertLog "A16 Base = $A16Base"}
                             A24   {variable A24Base; set A24Base [lindex $w 2]; InsertLog "A24 Base = $A24Base"}
                             A32   {variable A32Base; set A32Base [lindex $w 2]; InsertLog "A32 Base = $A32Base"}
                         }
                         variable Base; set Base $A32Base
                   }

                   OFFSET  {
                       set i [lindex $w 1]
                       if {$i < 32} {UpdateModule; do_SetThreshold $i [lindex $w 2]}
                       if {$i == 32} {do_SetFastClear [lindex $w 2]}
                       if {$i == 33} {do_SetFullScale [lindex $w 2]}
                   }

                   ENABLE  {UpdateModule; do_SetEnable [lindex $w 1] [lindex $w 2]}

                   ONLINE    {do_SetOperationMode ONLINE [lindex $w 1]}
                   OVERFLOW  {do_SetOperationMode OVERFLOW [lindex $w 1]}
                   STOPSTART {do_SetOperationMode STOPSTART [lindex $w 1]}
                   ZERO      {do_SetOperationMode THRESHOLD [lindex $w 1]}

                   SAVE      {UpdateModule; do_Save}
                   RESTORE   {do_Restore}

                   REDISPLAY  {} 

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data: [lindex $w 0]: $cgidata"}
               }
           }
       }
       UpdateModule
    }

}   ;# end of if {$started == 0}

